ON_MorphControl Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_nurbssurface.h>`

Inheritance diagram for ON_MorphControl:

## Public Member Functions

| ON_MorphControl ()
| ~ON_MorphControl ()
void | Destroy ()
void | MemoryRelocate ()
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
unsigned int | SizeOf () const
ON_BOOL32 | Write (ON_BinaryArchive &archive) const
ON_BOOL32 | Read (ON_BinaryArchive &archive)
ON::object_type | ObjectType () const
void | DestroyRuntimeCache (bool bDelete=true)
int | Dimension () const
ON_BOOL32 | GetBBox (double *boxmin, double *boxmax, int bGrowBox=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
void | ClearBoundingBox ()
ON_BOOL32 | Transform (const ON_Xform &xform)
ON_BOOL32 | HasBrepForm () const
ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
bool | IsRational () const
bool | MakeRational ()
bool | MakeNonRational ()
int | CVCount () const
int | CVCount (int dir) const
int | Order (int dir) const
const double * | Knot (int dir) const
ON_3dex | MaxCVIndex () const
const double * | CV (ON_3dex) const
double | Weight (ON_3dex) const
bool | AddControlLocalizer (double support_distance, double falloff_distance)
bool | AddSphereLocalizer (ON_3dPoint center, double support_distance, double falloff_distance)
bool | AddCylinderLocalizer (ON_Line axis, double support_distance, double falloff_distance)
bool | AddBoxLocalizer (ON_BoundingBox bbox, double support_distance, double falloff_distance)
bool | AddPlaneLocalizer (const ON_Plane &plane, double support_distance, double falloff_distance)
bool | AddConvexPolygonLocalizer (const ON_SimpleArray< ON_Plane > &planes, double support_distance, double falloff_distance)
bool | GetCageMorph (class ON_CageMorph &cage_morph) const
bool | IsIdentity (const ON_BoundingBox &bbox) const
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_COMPONENT_INDEX | ComponentIndex () const
virtual bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Public Attributes

int | m_varient
ON_NurbsCurve | m_nurbs_curve0
ON_NurbsCurve | m_nurbs_curve
ON_Interval | m_nurbs_curve_domain
ON_NurbsSurface | m_nurbs_surface0
ON_NurbsSurface | m_nurbs_surface
ON_Interval | m_nurbs_surface_domain [2]
ON_Xform | m_nurbs_cage0
ON_NurbsCage | m_nurbs_cage
ON_UuidList | m_captive_id
ON_ClassArray< ON_Localizer > | m_localizers
double | m_sporh_tolerance
bool | m_sporh_bQuickPreview
bool | m_sporh_bPreserveStructure

## Detailed Description

Definition at line 1736 of file opennurbs_nurbssurface.h.

## Constructor & Destructor Documentation

## ON_MorphControl()

ON_MorphControl::ON_MorphControl | ( |  | ) |

## ~ON_MorphControl()

ON_MorphControl::~ON_MorphControl | ( |  | ) |

## Member Function Documentation

## AddBoxLocalizer()

bool ON_MorphControl::AddBoxLocalizer | ( | ON_BoundingBox | bbox,
|  | double | support_distance,
|  | double | falloff_distance
| ) |  |

## AddControlLocalizer()

bool ON_MorphControl::AddControlLocalizer | ( | double | support_distance,
|  | double | falloff_distance
| ) |  |

## AddConvexPolygonLocalizer()

bool ON_MorphControl::AddConvexPolygonLocalizer | ( | const ON_SimpleArray< ON_Plane > & | planes,
|  | double | support_distance,
|  | double | falloff_distance
| ) |  |

## AddCylinderLocalizer()

bool ON_MorphControl::AddCylinderLocalizer | ( | ON_Line | axis,
|  | double | support_distance,
|  | double | falloff_distance
| ) |  |

## AddPlaneLocalizer()

bool ON_MorphControl::AddPlaneLocalizer | ( | const ON_Plane & | plane,
|  | double | support_distance,
|  | double | falloff_distance
| ) |  |

## AddSphereLocalizer()

bool ON_MorphControl::AddSphereLocalizer | ( | ON_3dPoint | center,
|  | double | support_distance,
|  | double | falloff_distance
| ) |  |

## BrepForm()

ON_Brep* ON_MorphControl::BrepForm | ( | ON_Brep * | brep = `NULL` | ) | const

virtual

Reimplemented from ON_Geometry.

## ClearBoundingBox()

void ON_MorphControl::ClearBoundingBox | ( |  | ) |

virtual

Reimplemented from ON_Geometry.

## CV()

const double* ON_MorphControl::CV | ( | ON_3dex |  | ) | const

## CVCount() [1/2]

int ON_MorphControl::CVCount | ( |  | ) | const

## CVCount() [2/2]

int ON_MorphControl::CVCount | ( | int | dir | ) | const

## Destroy()

void ON_MorphControl::Destroy | ( |  | ) |

## DestroyRuntimeCache()

void ON_MorphControl::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented from ON_Object.

## Dimension()

int ON_MorphControl::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Dump()

void ON_MorphControl::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## GetBBox()

ON_BOOL32 ON_MorphControl::GetBBox | ( | double * | boxmin,
|  | double * | boxmax,
|  | int | bGrowBox = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## GetCageMorph()

bool ON_MorphControl::GetCageMorph | ( | class ON_CageMorph & | cage_morph | ) | const

## GetTightBoundingBox()

bool ON_MorphControl::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

virtual

Reimplemented from ON_Geometry.

## HasBrepForm()

ON_BOOL32 ON_MorphControl::HasBrepForm | ( |  | ) | const

virtual

Reimplemented from ON_Geometry.

## IsIdentity()

bool ON_MorphControl::IsIdentity | ( | const ON_BoundingBox & | bbox | ) | const

## IsRational()

bool ON_MorphControl::IsRational | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_MorphControl::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## Knot()

const double* ON_MorphControl::Knot | ( | int | dir | ) | const

## MakeNonRational()

bool ON_MorphControl::MakeNonRational | ( |  | ) |

## MakeRational()

bool ON_MorphControl::MakeRational | ( |  | ) |

## MaxCVIndex()

ON_3dex ON_MorphControl::MaxCVIndex | ( |  | ) | const

## MemoryRelocate()

void ON_MorphControl::MemoryRelocate | ( |  | ) |

virtual

Reimplemented from ON_Object.

## ObjectType()

ON::object_type ON_MorphControl::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## Order()

int ON_MorphControl::Order | ( | int | dir | ) | const

## Read()

ON_BOOL32 ON_MorphControl::Read | ( | ON_BinaryArchive & | archive | ) |

virtual

Reimplemented from ON_Object.

## SizeOf()

unsigned int ON_MorphControl::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## Transform()

ON_BOOL32 ON_MorphControl::Transform | ( | const ON_Xform & | xform | ) |

virtual

Reimplemented from ON_Geometry.

## Weight()

double ON_MorphControl::Weight | ( | ON_3dex |  | ) | const

## Write()

ON_BOOL32 ON_MorphControl::Write | ( | ON_BinaryArchive & | archive | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

## m_captive_id

ON_UuidList ON_MorphControl::m_captive_id

Definition at line 1917 of file opennurbs_nurbssurface.h.

## m_localizers

ON_ClassArray<ON_Localizer> ON_MorphControl::m_localizers

Definition at line 1922 of file opennurbs_nurbssurface.h.

## m_nurbs_cage

ON_NurbsCage ON_MorphControl::m_nurbs_cage

Definition at line 1914 of file opennurbs_nurbssurface.h.

## m_nurbs_cage0

ON_Xform ON_MorphControl::m_nurbs_cage0

Definition at line 1913 of file opennurbs_nurbssurface.h.

## m_nurbs_curve

ON_NurbsCurve ON_MorphControl::m_nurbs_curve

Definition at line 1906 of file opennurbs_nurbssurface.h.

## m_nurbs_curve0

ON_NurbsCurve ON_MorphControl::m_nurbs_curve0

Definition at line 1905 of file opennurbs_nurbssurface.h.

## m_nurbs_curve_domain

ON_Interval ON_MorphControl::m_nurbs_curve_domain

Definition at line 1907 of file opennurbs_nurbssurface.h.

## m_nurbs_surface

ON_NurbsSurface ON_MorphControl::m_nurbs_surface

Definition at line 1910 of file opennurbs_nurbssurface.h.

## m_nurbs_surface0

ON_NurbsSurface ON_MorphControl::m_nurbs_surface0

Definition at line 1909 of file opennurbs_nurbssurface.h.

## m_nurbs_surface_domain

ON_Interval ON_MorphControl::m_nurbs_surface_domain[2]

Definition at line 1911 of file opennurbs_nurbssurface.h.

## m_sporh_bPreserveStructure

bool ON_MorphControl::m_sporh_bPreserveStructure

Definition at line 1927 of file opennurbs_nurbssurface.h.

## m_sporh_bQuickPreview

bool ON_MorphControl::m_sporh_bQuickPreview

Definition at line 1926 of file opennurbs_nurbssurface.h.

## m_sporh_tolerance

double ON_MorphControl::m_sporh_tolerance

Definition at line 1925 of file opennurbs_nurbssurface.h.

## m_varient

int ON_MorphControl::m_varient

Definition at line 1901 of file opennurbs_nurbssurface.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_nurbssurface.h